##########################################################################
#
# docextractaction.pm -- 
# A component of the Greenstone digital library software
# from the New Zealand Digital Library Project at the 
# University of Waikato, New Zealand.
#
# Copyright (C) 2009 New Zealand Digital Library Project
#
# This program is free software; you can redistr   te it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
###########################################################################

package docextractaction;

use strict;

use cgiactions::baseaction;

use dbutil;
use ghtml;

use JSON;


BEGIN {
    require XML::Rules;
}

@docextractaction::ISA = ('baseaction');

my $action_table =
{
	"extract-archives-doc" => { # where param can be ONE of: index (default), import, archives, live
	    'compulsory-args' => [ "d", "json-sections" ],
	    'optional-args'   => [ "json-metadata" ],
#	    'optional-args'   => [ "where" ],
	    'help-string' => [
		'document-extract.pl?a=extract-archives-doc&c=demo&d=HASH0123456789ABC&json-sections=["1.2","1.3.2","2.1","2.2"]&json-metadata=[{"metaname":"dc.Title","metavalue":"All Black Rugy Success","metamode":"accumulate"]'
		."\n\n Add site=xxxx if a Greenstone3 installation"
	    ]}

};


sub new 
{
    my $class = shift (@_);
    my ($gsdl_cgi,$iis6_mode) = @_;

    # Treat metavalue specially.  To transmit this through a GET request
    # the Javascript side has url-encoded it, so here we need to decode
    # it before proceeding

#    my $url_encoded_metavalue = $gsdl_cgi->param("metavalue");
#    my $url_decoded_metavalue = &unicode::url_decode($url_encoded_metavalue,1);
#    my $unicode_array = &unicode::utf82unicode($url_decoded_metavalue);

#    $url_decoded_metavalue = join("",map(chr($_),@$unicode_array));
#    $gsdl_cgi->param("metavalue",$url_decoded_metavalue);

    my $self = new baseaction($action_table,$gsdl_cgi,$iis6_mode);

    return bless $self, $class;
}


# JSON version that will get the requested metadata values 
# from the requested source (index, import, archives or live)
# One of the params is a JSON string and the return value is JSON too
# http://forums.asp.net/t/1844684.aspx/1 - Web api method return json in string
sub extract_archives_doc
{
    my $self = shift @_;

#    my $where = $self->{'where'};
#    if (!$where) {	
#	$where = "index"; # default behaviour is to get the values from index
#    }

    # Only when setting metadata do we perform authentication and do we lock the collection,
    # not when getting metadata

    # for get_meta_array, the where param can only be ONE of import, archives, index, live
#    if($where =~ m/index/) {
#	$self->_get_index_metadata_array(@_);
#    }
#    elsif($where =~ m/archives/) {
#	$self->_get_archives_metadata_array(@_);
#    }
#    elsif($where =~ m/import/) {
#	$self->_get_import_metadata_array(@_);
#    }
#    elsif($where =~ m/live/) {
#    	$self->_get_live_metadata_array(@_);
#    }
}


1;
